
if (exist("tol","var")==0)
 tol=10^(-7);
end

if (exist("seco","var")==0)
 seco=0;
end
if (exist("minu","var")==0)
 minu=0;
end
if (exist("hour","var")==0)
 hour=0;
end
if hour==0 && minu==0 && seco==0
 seco=3;
end

printf("This program will run for at most ")
if hour>0
 printf("%d hour(s) ",hour)
end
if minu>0
 printf("%d minutes(s) ",minu)
end
if seco>0
 printf("%d second(s)",seco)
end
printf(".\n")

fflush(stdout);  %This makes output appear on the screen immediately
                 %and not only after the program is finished.

tt=(60*hour+minu)*60+seco;    %time in seconds that the program should run
begin=clock;

d=size(P)(1);
K=eye(d);
erro=Inf;
while min([erro>tol etime(clock,begin)<tt])
 Q=Qfunc(P,K,Z);
 K=K+P*K-K*Q;
 K=max(K,0);
 K=K./sum(K,2);
 erro=max(max(abs(P*K-K*Q)));
end

Q=Q.*(abs(Q)>tol);

printf("Time elapsed %d seconds.\n",etime(clock,begin))
printf("Error %g.\n",erro)
printf("Calculated quantities Q, K, erro.\n")
